package entities;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.ManyToMany;
import javax.persistence.OrderBy;

@Entity
public class Customer implements Serializable {

    @Id
    private Long id;

    @ManyToMany(mappedBy="customers", fetch=FetchType.EAGER)
    @OrderBy("cost ASC")
    private List<RetailOrder> orders = new ArrayList<RetailOrder>();
    
    public Customer() {
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public int hashCode() {
        int hash = 0;
        hash += (this.getId() != null ? this.getId().hashCode() : 0);
        return hash;
    }

    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Customer)) {
            return false;
        }
        Customer other = (Customer)object;
        if (this.getId() != other.getId() && (this.getId() == null || !this.getId().equals(other.getId()))) return false;
        return true;
    }

    public String toString() {
        return "entities.union.Customer[id=" + getId() + "]";
    }

    public void addOrder(RetailOrder order) {
        this.getOrders().add(order);
    }

    public List<RetailOrder> getOrders() {
        return orders;
    }

    public void setOrders(List<RetailOrder> orders) {
        this.orders = orders;
    }
    
}
