package entities;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.ManyToMany;

@Entity
public class RetailOrder implements Serializable {
    
    @Id
    private Long id;
    
    private double cost;
    
    @ManyToMany()
    private Set<Customer> customers = new HashSet();
    
    public RetailOrder() {
    }
    
    public Long getId() {
        return id;
    }
    
    public void setId(Long id) {
        this.id = id;
    }
    
    public int hashCode() {
        int hash = 17;
        hash += 37 * hash + Double.doubleToLongBits(cost);
        return hash;
    }
    
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof RetailOrder)) {
            return false;
        }
        RetailOrder other = (RetailOrder)object;
        if (Double.doubleToLongBits(this.cost) == Double.doubleToLongBits(other.cost)){
            return true;
        }
        
        return false;
    }
    
    public String toString() {
        return "entities.union.RetailOrder[id=" + getId() + "]";
    }
    
    public Set<Customer> getCustomers() {
        return customers;
    }
    
    public void setCustomers(Set<Customer> customers) {
        this.customers = customers;
    }
    
    public void addCustomer(Customer customer) {
        this.getCustomers().add(customer);
    }
    
    public double getCost() {
        return cost;
    }
    
    public void setCost(double cost) {
        this.cost = cost;
    }
    
}
